*Program to decode a foxpro index file: see http://blogs.msdn.com/calvin_hsia/archive/2005/01/05/347388.aspx 

CLEAR ALL 

CLOSE all 

SET SAFETY off 

CLEAR 

MODIFY COMMAND PROGRAM() nowait 

#if .t. 

*Create an indexed table with very regular data, so it can be examined easily 

CREATE TABLE test (name c(20), address c(30), zip c(11)) 

INDEX on UPPER(name) FOR 7 < 8 AND SECONDS()>0 TAG name && have a FOR expression 
that is always true for demo 

INDEX on UPPER(address) TAG address 

INDEX on UPPER(zip) TAG zip 

INSERT INTO test (name,address,zip) VALUES ("fred ","52 anywhere","z11111") 

INSERT INTO test (name,address,zip) VALUES ("barney","23 anywhere","z22222") 

INSERT INTO test (name,address,zip) VALUES ("wilma ","33 anywhere","z33333") 

INSERT INTO test (name,address,zip) VALUES ("betty ","43 anywhere","z44444") 

FOR i = 5 TO 10 && try 100, 1000, 10000 

* use this line for not very compressible data 

INSERT INTO test (name,address,zip) VALUES (padr(i,5,"0")+"n"+PADL(i,5,"0"),padr(i,5,"0")+"a"+PADL(i,5,"0"),padr(i,5,"0")+"z"+PADL(i,5,"0")) 

*use this line for very compressible data 

* INSERT INTO test (name,address,zip) VALUES ("n"+PADL(i,5,"0"),"a"+PADL(i,5,"0"),"z"+PADL(i,5,"0")) 

ENDFOR 

USE 

#endif 

#define NODESIZE 512 

#define WMASK 65535 &&2^16 -1 0xFFFF 

#define IXO_TAG 0x80 

#define IXO_MDX 0x40 && Index header is a cdx header 

#define IXNROOT 1 && /* this is the root node */ 

#define IXNLEAF 2 && /* this is a leaf node */ 

DecodeIndex("test.cdx") && or any fullpath to a CDX file 

PROCEDURE DecodeIndex(cIndexFile as String) 

oRoot=0 

Hndx=0 

TRY 

hNdx=FOPEN(cIndexFile) 

IF hNdx<=1 

THROW "error opening "+cIndexFile 

ENDIF 

SET PRINT TO tt.txt 

SET PRINTER on 

SET CONSOLE off 

oRoot=CREATEOBJECT("tagnode",0,0) 

?cIndexFile 

oRoot.Showit() 

CATCH TO oError 

?"Err",oError.LineNo,oError.details,oError.LineContents,oError.Message 

ENDTRY 

SET PRINTER off 

SET PRINT to 

SET CONSOLE on 

FCLOSE(hNdx) 

CLEAR all 

MODIFY FILE tt.txt nowait 

DEFINE CLASS tagnode as ixnode && one of these per index tag 

ixKeyLen=0 

IxOptions=0 

Sector2=0 

PROCEDURE init(nAddr as Integer,nDepth as String) 

DODEFAULT(nAddr,nDepth) 

WITH this 

.fIsTagNode=.t. 

.IxOptions=ASC(SUBSTR(.buffer,4*3+1+2,1)) 

.IxKeyLen=CTOBIN(substr(.buffer,4*3+1,2),"2rs") 

RootAddr=CTOBIN(LEFT(.buffer,4),"4rs") 

IxSignature=ASC(SUBSTR(.buffer,4*3+1+3,1)) 

IF BITAND(.ixOptions,IXO_TAG)>0 

.oChild=CREATEOBJECT("ixnode",RootAddr,nDepth+1) 

.oChild.oTag=this && ptr to TAG node 

.oChild.FillIt() 

ENDIF 

IF BITAND(.ixOptions,IXO_MDX)>0 

.Sector2=CREATEOBJECT("sector",.nAddr+NODESIZE) && an MDX is a double size node 

ENDIF 

ENDWITH 

ENDDEFINE 

DEFINE CLASS ixnode as sector 

oTag=0 

nDepth=0 

fIsTagNode=.f. 

oChild=0 

oSiblings=0 

nAttr=0 

nKeys=0 

nLeft=0 

nRight=0 

nAvail=0 

rMask=0 

dMask=0 

tMask=0 

rBits=0 

dBits=0 

tBits=0 

mLen=0 

PROCEDURE showit() && recursive procedure to show the entire tree 

LOCAL cKey,rn,i 

WITH this 

?REPLICATE(" ",.nDepth)+TRANSFORM(.nDepth),TRANSFORM(.nAddr,"@0x")+" "+.class+" 
" 

IF .fIsTagNode && AND BITAND(.ixOptions,IXO_TAG)=0 

??TRANSFORM(.ixOptions,"@0x"),TRANSFORM(CTOBIN(LEFT(.buffer,4),"4rs"),"@0x")+" " 

nKeyExprLen=CTOBIN(SUBSTR(.buffer,512-2,2),"2s") 

??LEFT(.Sector2.buffer,nKeyExprLen-1) 

nForExprLen=CTOBIN(SUBSTR(.buffer,512-6,2),"2s") 

IF nForExprLen>1 

nForExprOffset=CTOBIN(SUBSTR(.buffer,512-8,2),"2s") 

??" FOR ",SUBSTR(.Sector2.buffer,nForExprOffset+1,nForExprLen-1) 

ENDIF 

ELSE 

??TRANSFORM(.nAttr)+" "+TRANSFORM(.nleft,"@0x"),TRANSFORM(.nRight,"@0x"),padr(.nKeys,3) 

cKey="" 

nKeyPoolOff=NODESIZE 

FOR i = 1 TO .nKeys 

rn=.GetKey(i,@cKey,@nKeyPoolOff) 

??ALLTRIM(cKey)+" " 

IF BITAND(.nAttr,IXNLEAF)>0 AND .nDepth > 1 &&should we output in hex ? 

??padr(rn,5)," " 

ELSE 

??TRANSFORM(rn,"@0x")," " 

ENDIF 

ENDFOR 

ENDIF 

IF VARTYPE(.oChild)="O" 

.oChild.Showit() 

ENDIF 

IF VARTYPE(.oSiblings)="O" 

.oSiblings.Showit() 

ENDIF 

ENDWITH 

PROCEDURE FillIt && recursive procedure to fill the tree 

LOCAL i,cKey,cClass,dwAddr,oSib 

WITH this 

IF .fIsTagNode 

dwAddr=CTOBIN(LEFT(.buffer,4),"4rs") 

.oChild=CREATEOBJECT("ixnode",dwAddr,.nDepth+1) 

.oChild.oTag=this && ptr to TAG node 

.oChild.FillIt() 

ELSE 

IF BITAND(.nAttr, IXNLEAF)=0 OR .nDepth=1 && and BITAND(.nAttr, IXNROOT)=0 

cClass=IIF(.nDepth<2,"tagnode","ixnode") 

cKey="" 

nKeyPoolOff=NODESIZE 

FOR i = 1 TO .nKeys 

dwAddr = .GetKey(i, @cKey,@nKeyPoolOff) 

IF VARTYPE(.oChild)!= 'O' 

.oChild=CREATEOBJECT(cClass,dwAddr,.nDepth+1) 

.oChild.oTag=.oTag 

.oChild.FillIt() 

ELSE 

oSib=CREATEOBJECT(cClass,dwAddr,.nDepth+1) 

oSib.oTag=.oTag 

oSib.FillIt() 

oTemp=.oChild.oSiblings 

IF VARTYPE(oTemp)!='O' 

.oChild.oSiblings=oSib 

ELSE 

DO WHILE VARTYPE(oTemp.oSiblings)="O" && add siblings at the end 

oTemp=oTemp.oSiblings 

ENDDO 

oTemp.oSiblings=oSib 

ENDIF 

ENDIF 

ENDFOR 

ENDIF 

ENDIF 

ENDWITH 

PROCEDURE init(nAddr as Integer,nDepth as Integer) as VOID 

LOCAL i,cKey 

this.nDepth=nDepth 

DODEFAULT(nAddr) 

IF this.class!="Ixnode" 

RETURN 

ENDIF 

WITH this 

.nAttr=CTOBIN(SUBSTR(.buffer,1,2),"2rs") 

.nKeys=CTOBIN(SUBSTR(.buffer,3,2),"2rs") 

.nLeft=CTOBIN(SUBSTR(.buffer,5,4),"4rs") 

.nRight=CTOBIN(SUBSTR(.buffer,9,4),"4rs") 

IF BITAND(.nAttr, IXNLEAF)=0 

*interior node 

ELSE 

.nAvail=CTOBIN(SUBSTR(.buffer,13,2),"2rs") 

.rMask=CTOBIN(SUBSTR(.buffer,15,4),"4rs") 

.dMask=ASC(SUBSTR(.buffer,19)) 

.tMask=ASC(SUBSTR(.buffer,20)) 

.rBits=ASC(SUBSTR(.buffer,21)) 

.dBits=ASC(SUBSTR(.buffer,22)) 

.tBits=ASC(SUBSTR(.buffer,23)) 

.mLen=ASC(SUBSTR(.buffer,24)) 

ENDIF 

ENDWITH 

PROCEDURE GetKey(nKey as Integer, cKey as string @, nKeyPoolOff as Integer @) as 
Integer 

LOCAL i,kLen,rn,nKeyPoolOff,nKeyOff,val,duplen,traillen,ntmp 

WITH this 

kLen=.oTag.ixKeyLen 

IF BITAND(.nAttr, IXNLEAF)=0 && interior nodes are not compressed 

cKey=SUBSTR(.Buffer,13+(nKey-1)*(kLen+8), kLen) 

rn=CTOBIN(SUBSTR(.Buffer,13+(nKey)*(kLen+8)-4, 4),"4s") 

ELSE 

nKeyOff=25+(nKey-1)*.mLen && skip the node header bytes 

rn = CTOBIN(SUBSTR(.buffer,nKeyOff,4),"4rs") 

rn=BITAND(rn,.rMask) 

val= CTOBIN(SUBSTR(.buffer,nKeyOff+(.mLen-2),2),"2rs") 

duplen=0 

traillen= .RotateLeft(val,@duplen) 

ntmp=kLen-traillen-duplen 

nKeyPoolOff = nKeyPoolOff-nTmp 

cKey=PADR(LEFT(ckey,duplen)+SUBSTR(.buffer,nKeyPoolOff+1 , nTmp),kLen," ") 

ENDIF 

ENDWITH 

RETURN rn 

HIDDEN PROCEDURE RotateLeft(nNum as Integer, duplen as Integer @) && low level 
bit manipulation 

LOCAL nval 

nval=BITLSHIFT(nNum,this.tBits) 

nval=BITAND(nval + BITRSHIFT(nNum,16-this.tBits),WMASK) 

nTrailen=BITAND(nval,2^this.tBits-1) 

nval=BITLSHIFT(nNum,this.dBits) 

nval=BITAND(nval + BITRSHIFT(nVal,16-this.dBits),WMASK) 

duplen=BITAND(nval,2^this.dBits-1) 

RETURN nTrailen 

ENDDEFINE 

DEFINE CLASS sector as session 

buffer=0 && the 512 bytes of raw node data 

nAddr=0 && address of the sector in the file 

PROCEDURE init(nAddr) 

this.ReadBuf(nAddr) 

PROCEDURE ReadBuf(nAddr) 

this.nAddr=nAddr 

FSEEK(Hndx,nAddr,0) 

this.buffer=FREAD(Hndx,NODESIZE) 

ENDDEFINE 

